/*---------------------------------------------------------------------------------

	$Id: main.c,v 1.4 2005/09/17 23:15:13 wntrmute Exp $

	Simple console print demo
	-- dovoto

	$Log: main.c,v $
	Revision 1.4  2005/09/17 23:15:13  wntrmute
	corrected iprintAt in templates
	
	Revision 1.3  2005/09/05 00:32:20  wntrmute
	removed references to IPC struct
	replaced with API functions
	
	Revision 1.2  2005/08/31 01:26:30  wntrmute
	updated to work with new stdio support

	Revision 1.1  2005/08/03 06:29:56  wntrmute
	added templates


---------------------------------------------------------------------------------*/
#include <nds.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <nds/arm9/console.h> //basic print funcionality
#include "keyboard.h"

#define ECHO_ON	 0
#define ECHO_OFF 1

#define MAX_TEXT 256

void waitForVBlank(void)
{
	while(!(REG_DISPSTAT & DISP_IN_VBLANK));
	while((REG_DISPSTAT & DISP_IN_VBLANK));
}

//---------------------------------------------------------------------------------
int main(void) {
//---------------------------------------------------------------------------------
	//touchPosition touchXY;

	videoSetMode(MODE_0_2D | DISPLAY_BG0_ACTIVE);	// bg 0 will be used to print text
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);
	vramSetBankA(VRAM_A_MAIN_BG);
	vramSetBankC(VRAM_C_SUB_BG);

	BG0_CR = BG_MAP_BASE(31);

	BG_PALETTE[255] = RGB15(31,31,31);	//by default font will be rendered with color 255

	//consoleInit() is a lot more flexible but this gets you up and running quick
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK(31), (u16*)CHAR_BASE_BLOCK(0), 16); 

	iprintf("\n\n\tKeyboard Example 5\n");
	iprintf("\tby Headspin\n\n");
	
	initKeyboard();
	
	char str[MAX_TEXT] = "";

	while(1) {

		scanKeys();
		
		if(processKeyboard(&str[0], MAX_TEXT, ECHO_ON)=='\n')
		{
			// process input
			//iprintf(str);
			strcpy(str, "");
		}

		waitForVBlank();

	}

	return 0;
}
